#include <bits/stdc++.h>+
#define all(x) (x).begin(),(x).end()
#define ll long long
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin>>n>>m;
    vector<ll> ooo(m, 0);
    vector<vector<ll> > a(n, ooo), s(n, ooo);
    ll suma=0;
    for(int i=0; i<n; i++){
        for(int j=0; j<m; j++){
            cin>>a[i][j];
            suma+=a[i][j];
        }
    }
    s[0][0]=a[0][0];
    //cout<<s[0][0];
    for(int i=1; i<n; i++){
        s[i][0]=s[i-1][0]+a[i][0];
    }
    for(int j=1; j<m; j++){
        s[0][j]=s[0][j-1]+a[0][j];
    }
    for(int i=1; i<n; i++){
        for(int j=1; j<m; j++){
            s[i][j]=a[i][j]+max(s[i-1][j], s[i][j-1]);
            //cout<<s[i][j]<<' ';
        }
        //cout<<endl;
    }
    ll br=s[n-1][m-1];
    cout<<min(suma, suma+n+m-1-br-br);
    return 0;
}